# -*- coding: utf-8 -*-
"""
Created on Tue May 16 07:14:07 2017

@author: Cliff
"""
import numpy as np


#from sklearn.linear_model import LogisticRegression
#from rank import my_rank
def scale_model(filename, fwn):
    fr = open(filename, 'r')
    lines = [line.strip() for line in fr.readlines()]
    fr.close()

    mydat = []
    rownames = []
    for k in range(len(lines)):
        ### skip one line header
        if lines[k]:
            if lines[k][0] == '#':
                myheader = lines[k]  #.split(',')
            else:
                aline = lines[k].split(',')
                rownames.append(aline[0])
                bline = []
                for j in range(1, len(aline)):
                    #rownames.append(aline[0])
                    bline.append(aline[j])
                mydat.append(bline)
    mydat = np.array(mydat, dtype=float)

    ####
    amax = np.max(mydat, axis=0)
    amin = np.min(mydat, axis=0)
    print(amax)
    print(amin)
    arng = amax - amin
    print(arng)
    row, col = mydat.shape
    bdat = np.zeros((row, col))
    for i in range(row):
        for j in range(col):
            if arng[j] == 0:
                bdat[i][j] = 0
                print(j, "zero")
            else:
                bdat[i][j] = (mydat[i][j] - amin[j]) * 1.0 / arng[j]
            #bdat[i][j]=mydat[i][j]/amax[j]
    xbdat = np.column_stack((rownames, bdat))
    #fw=open("model.scale.csv",'w')
    #fwn="model.scale.csv"
    #np.savetxt(fwn,bdat,fmt="%f",delimiter=",")
    np.savetxt(fwn, xbdat, fmt="%s", delimiter=",", header=myheader)
    """
    for i in range(row):
        for j in range(col):
            if j==col-1:
                fw.write("%.5f," %(bdat[i][j]))
            else:
                fw.write("%.5f\n" %bdat[i][j])
    fw.close()
    """
    return (bdat)


if False:
    #### combine my results and ZhaoPeng's results
    frn = "model.features.csv"
    fwn = "model.features.scale.csv"
    scale_model(frn, fwn)
