﻿# updated at 2019 March 18

Predicting essential proteins from protein-protein interactions using order statistics

[esPOS Online](https://sourceforge.net/projects/espos/)

# Run
```
# python 2.7

cd ./bin

# YDIP_4746
python standalone.py 1
# YDIP_5093
python standalone.py 2
# YBioGRID
python standalone.py 3
```

Your results will be stored in ```output``` directory.

# Results file example(on YDIP dataset)

printing result:

```
orignal_network nodes: 4746  edges: 15166 
network(rf by gene)        nodes: 4746  edges: 13148 
network(rf by sublocation) nodes: 4746  edges: 6456 
[3.50956114e+06 2.65378726e+01 3.45350279e+01]
[1. 0. 0.]
[3.50956014e+06 2.65378726e+01 3.45350279e+01]
([(100, 86), (200, 161), (300, 225), (400, 278), (500, 339), (600, 374), (48, 42), (238, 187), (475, 327), (712, 416), (950, 505), (1187, 553)], 0.7088888888888889)
[547, 583, 583, 3033, 1130, 3616, 0.7543194268857986, 0.484070796460177, 0.8387721238938053, 0.3228429203539823, 0.484070796460177, 0.484070796460177, 0.484070796460177, 0.8387721238938053]
```

1. YDIP.refine.network.txt

    refined network (using gene expression data and subcellular location scores)
    write graph in single-line adjacency-list format

2. YDIP.features.csv

    scores of all nodes on "SC, PeC, NCgeneW",
    
    each line contains 5 values:
    * name: name of the node
    * label: 1 represents essential protein, 0 represents non-essential protein
    * SC: score of SC
    * PeC: score of PeC
    * NCgeneW: score of NCgeneW
    
3. YDIP.features.scale.csv

    scaled scores of ```YDIP.features.csv```
    
4. YDIP.out.best.label.pred.csv

    last predicted score of each node


# Contact
If you have any questions please contact me  gaojz@nankai.edu.cn
